import { CSSProperties, RefObject } from 'react';
import { CursorStylePayload, GlobalStyle } from './style';
export declare function useHideSystemCursor<T extends HTMLElement>(hoverTarget?: RefObject<T>): void;
export declare function useGlobalStyle({ color, height, width }?: Partial<GlobalStyle>): GlobalStyle;
export declare function useStyles(): {
    ref: (payload: HTMLElement | ((previousValue: undefined) => undefined) | ((previousValue: null) => null) | ((previousValue: HTMLElement) => HTMLElement) | null | undefined) => void;
    style: CSSProperties;
};
export declare function useCursorStyle<T extends HTMLElement>(...payloads: [CursorStylePayload, ...CursorStylePayload[]]): import("react").MutableRefObject<T | null>;
export declare function useCursorStyleOnHover<T extends HTMLElement>(...payloads: [CursorStylePayload, ...CursorStylePayload[]]): RefObject<T>;
