import type { Maybe } from './types';
export declare function isDifferent<T>(data: T): (element: T) => boolean;
export declare function isDefined<T>(data: Maybe<T>): data is T;
export declare function mapTuple<T, U>([element, ...tuple]: [T, ...T[]], callback: (element: T) => U): [U, ...U[]];
