import Xe, { createContext as zr, useContext as Mr, useSyncExternalStore as Wr, useCallback as Yr, useRef as j, useEffect as me, useLayoutEffect as Lr, memo as Hr, isValidElement as Nr, Children as qr, cloneElement as Ur } from "react";
function Br(t) {
  const r = zr(void 0);
  r.displayName = t.name;
  function n() {
    var a;
    const i = Mr(r);
    if (!i)
      throw new Error(`[${t.name}] ${(a = t.errorMessage) != null ? a : "Context Provider is missing."}`);
    return i;
  }
  return [r.Provider, n];
}
function Ke(t) {
  return (r) => t !== r;
}
function be(t) {
  return t != null;
}
function Ze([t, ...r], n) {
  return [n(t), ...r.map(n)];
}
function Gr(t) {
  const r = /* @__PURE__ */ new Set();
  let n = { ...t };
  function i() {
    r.forEach((a) => a());
  }
  return Object.freeze({
    get() {
      return n;
    },
    set(a) {
      n = { ...n, ...typeof a == "function" ? a(n) : a }, i();
    },
    setProperty(a, u) {
      n = { ...n, [a]: typeof u == "function" ? u(n[a]) : u }, i();
    },
    subscribe(a) {
      return r.add(a), () => r.delete(a);
    }
  });
}
var ge = { exports: {} }, M = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var He;
function Jr() {
  if (He)
    return M;
  He = 1;
  var t = Xe, r = Symbol.for("react.element"), n = Symbol.for("react.fragment"), i = Object.prototype.hasOwnProperty, a = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, u = { key: !0, ref: !0, __self: !0, __source: !0 };
  function f(m, d, c) {
    var g, y = {}, E = null, k = null;
    c !== void 0 && (E = "" + c), d.key !== void 0 && (E = "" + d.key), d.ref !== void 0 && (k = d.ref);
    for (g in d)
      i.call(d, g) && !u.hasOwnProperty(g) && (y[g] = d[g]);
    if (m && m.defaultProps)
      for (g in d = m.defaultProps, d)
        y[g] === void 0 && (y[g] = d[g]);
    return { $$typeof: r, type: m, key: E, ref: k, props: y, _owner: a.current };
  }
  return M.Fragment = n, M.jsx = f, M.jsxs = f, M;
}
var W = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var Ne;
function Xr() {
  return Ne || (Ne = 1, process.env.NODE_ENV !== "production" && function() {
    var t = Xe, r = Symbol.for("react.element"), n = Symbol.for("react.portal"), i = Symbol.for("react.fragment"), a = Symbol.for("react.strict_mode"), u = Symbol.for("react.profiler"), f = Symbol.for("react.provider"), m = Symbol.for("react.context"), d = Symbol.for("react.forward_ref"), c = Symbol.for("react.suspense"), g = Symbol.for("react.suspense_list"), y = Symbol.for("react.memo"), E = Symbol.for("react.lazy"), k = Symbol.for("react.offscreen"), N = Symbol.iterator, V = "@@iterator";
    function q(e) {
      if (e === null || typeof e != "object")
        return null;
      var o = N && e[N] || e[V];
      return typeof o == "function" ? o : null;
    }
    var _ = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function R(e) {
      {
        for (var o = arguments.length, s = new Array(o > 1 ? o - 1 : 0), l = 1; l < o; l++)
          s[l - 1] = arguments[l];
        ar("error", e, s);
      }
    }
    function ar(e, o, s) {
      {
        var l = _.ReactDebugCurrentFrame, v = l.getStackAddendum();
        v !== "" && (o += "%s", s = s.concat([v]));
        var h = s.map(function(b) {
          return String(b);
        });
        h.unshift("Warning: " + o), Function.prototype.apply.call(console[e], console, h);
      }
    }
    var or = !1, ir = !1, sr = !1, ur = !1, fr = !1, he;
    he = Symbol.for("react.module.reference");
    function lr(e) {
      return !!(typeof e == "string" || typeof e == "function" || e === i || e === u || fr || e === a || e === c || e === g || ur || e === k || or || ir || sr || typeof e == "object" && e !== null && (e.$$typeof === E || e.$$typeof === y || e.$$typeof === f || e.$$typeof === m || e.$$typeof === d || e.$$typeof === he || e.getModuleId !== void 0));
    }
    function cr(e, o, s) {
      var l = e.displayName;
      if (l)
        return l;
      var v = o.displayName || o.name || "";
      return v !== "" ? s + "(" + v + ")" : s;
    }
    function ye(e) {
      return e.displayName || "Context";
    }
    function C(e) {
      if (e == null)
        return null;
      if (typeof e.tag == "number" && R("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof e == "function")
        return e.displayName || e.name || null;
      if (typeof e == "string")
        return e;
      switch (e) {
        case i:
          return "Fragment";
        case n:
          return "Portal";
        case u:
          return "Profiler";
        case a:
          return "StrictMode";
        case c:
          return "Suspense";
        case g:
          return "SuspenseList";
      }
      if (typeof e == "object")
        switch (e.$$typeof) {
          case m:
            var o = e;
            return ye(o) + ".Consumer";
          case f:
            var s = e;
            return ye(s._context) + ".Provider";
          case d:
            return cr(e, e.render, "ForwardRef");
          case y:
            var l = e.displayName || null;
            return l !== null ? l : C(e.type) || "Memo";
          case E: {
            var v = e, h = v._payload, b = v._init;
            try {
              return C(b(h));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var O = Object.assign, A = 0, xe, Se, Ee, Re, we, Pe, _e;
    function Ce() {
    }
    Ce.__reactDisabledLog = !0;
    function dr() {
      {
        if (A === 0) {
          xe = console.log, Se = console.info, Ee = console.warn, Re = console.error, we = console.group, Pe = console.groupCollapsed, _e = console.groupEnd;
          var e = {
            configurable: !0,
            enumerable: !0,
            value: Ce,
            writable: !0
          };
          Object.defineProperties(console, {
            info: e,
            log: e,
            warn: e,
            error: e,
            group: e,
            groupCollapsed: e,
            groupEnd: e
          });
        }
        A++;
      }
    }
    function pr() {
      {
        if (A--, A === 0) {
          var e = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: O({}, e, {
              value: xe
            }),
            info: O({}, e, {
              value: Se
            }),
            warn: O({}, e, {
              value: Ee
            }),
            error: O({}, e, {
              value: Re
            }),
            group: O({}, e, {
              value: we
            }),
            groupCollapsed: O({}, e, {
              value: Pe
            }),
            groupEnd: O({}, e, {
              value: _e
            })
          });
        }
        A < 0 && R("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var ee = _.ReactCurrentDispatcher, re;
    function U(e, o, s) {
      {
        if (re === void 0)
          try {
            throw Error();
          } catch (v) {
            var l = v.stack.trim().match(/\n( *(at )?)/);
            re = l && l[1] || "";
          }
        return `
` + re + e;
      }
    }
    var te = !1, B;
    {
      var mr = typeof WeakMap == "function" ? WeakMap : Map;
      B = new mr();
    }
    function Te(e, o) {
      if (!e || te)
        return "";
      {
        var s = B.get(e);
        if (s !== void 0)
          return s;
      }
      var l;
      te = !0;
      var v = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var h;
      h = ee.current, ee.current = null, dr();
      try {
        if (o) {
          var b = function() {
            throw Error();
          };
          if (Object.defineProperty(b.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(b, []);
            } catch (T) {
              l = T;
            }
            Reflect.construct(e, [], b);
          } else {
            try {
              b.call();
            } catch (T) {
              l = T;
            }
            e.call(b.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (T) {
            l = T;
          }
          e();
        }
      } catch (T) {
        if (T && l && typeof T.stack == "string") {
          for (var p = T.stack.split(`
`), w = l.stack.split(`
`), x = p.length - 1, S = w.length - 1; x >= 1 && S >= 0 && p[x] !== w[S]; )
            S--;
          for (; x >= 1 && S >= 0; x--, S--)
            if (p[x] !== w[S]) {
              if (x !== 1 || S !== 1)
                do
                  if (x--, S--, S < 0 || p[x] !== w[S]) {
                    var P = `
` + p[x].replace(" at new ", " at ");
                    return e.displayName && P.includes("<anonymous>") && (P = P.replace("<anonymous>", e.displayName)), typeof e == "function" && B.set(e, P), P;
                  }
                while (x >= 1 && S >= 0);
              break;
            }
        }
      } finally {
        te = !1, ee.current = h, pr(), Error.prepareStackTrace = v;
      }
      var F = e ? e.displayName || e.name : "", Le = F ? U(F) : "";
      return typeof e == "function" && B.set(e, Le), Le;
    }
    function br(e, o, s) {
      return Te(e, !1);
    }
    function gr(e) {
      var o = e.prototype;
      return !!(o && o.isReactComponent);
    }
    function G(e, o, s) {
      if (e == null)
        return "";
      if (typeof e == "function")
        return Te(e, gr(e));
      if (typeof e == "string")
        return U(e);
      switch (e) {
        case c:
          return U("Suspense");
        case g:
          return U("SuspenseList");
      }
      if (typeof e == "object")
        switch (e.$$typeof) {
          case d:
            return br(e.render);
          case y:
            return G(e.type, o, s);
          case E: {
            var l = e, v = l._payload, h = l._init;
            try {
              return G(h(v), o, s);
            } catch {
            }
          }
        }
      return "";
    }
    var J = Object.prototype.hasOwnProperty, ke = {}, Oe = _.ReactDebugCurrentFrame;
    function X(e) {
      if (e) {
        var o = e._owner, s = G(e.type, e._source, o ? o.type : null);
        Oe.setExtraStackFrame(s);
      } else
        Oe.setExtraStackFrame(null);
    }
    function vr(e, o, s, l, v) {
      {
        var h = Function.call.bind(J);
        for (var b in e)
          if (h(e, b)) {
            var p = void 0;
            try {
              if (typeof e[b] != "function") {
                var w = Error((l || "React class") + ": " + s + " type `" + b + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[b] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw w.name = "Invariant Violation", w;
              }
              p = e[b](o, b, l, s, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (x) {
              p = x;
            }
            p && !(p instanceof Error) && (X(v), R("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", l || "React class", s, b, typeof p), X(null)), p instanceof Error && !(p.message in ke) && (ke[p.message] = !0, X(v), R("Failed %s type: %s", s, p.message), X(null));
          }
      }
    }
    var hr = Array.isArray;
    function ne(e) {
      return hr(e);
    }
    function yr(e) {
      {
        var o = typeof Symbol == "function" && Symbol.toStringTag, s = o && e[Symbol.toStringTag] || e.constructor.name || "Object";
        return s;
      }
    }
    function xr(e) {
      try {
        return je(e), !1;
      } catch {
        return !0;
      }
    }
    function je(e) {
      return "" + e;
    }
    function Ie(e) {
      if (xr(e))
        return R("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", yr(e)), je(e);
    }
    var z = _.ReactCurrentOwner, Sr = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Fe, $e, ae;
    ae = {};
    function Er(e) {
      if (J.call(e, "ref")) {
        var o = Object.getOwnPropertyDescriptor(e, "ref").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return e.ref !== void 0;
    }
    function Rr(e) {
      if (J.call(e, "key")) {
        var o = Object.getOwnPropertyDescriptor(e, "key").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return e.key !== void 0;
    }
    function wr(e, o) {
      if (typeof e.ref == "string" && z.current && o && z.current.stateNode !== o) {
        var s = C(z.current.type);
        ae[s] || (R('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', C(z.current.type), e.ref), ae[s] = !0);
      }
    }
    function Pr(e, o) {
      {
        var s = function() {
          Fe || (Fe = !0, R("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        s.isReactWarning = !0, Object.defineProperty(e, "key", {
          get: s,
          configurable: !0
        });
      }
    }
    function _r(e, o) {
      {
        var s = function() {
          $e || ($e = !0, R("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        s.isReactWarning = !0, Object.defineProperty(e, "ref", {
          get: s,
          configurable: !0
        });
      }
    }
    var Cr = function(e, o, s, l, v, h, b) {
      var p = {
        $$typeof: r,
        type: e,
        key: o,
        ref: s,
        props: b,
        _owner: h
      };
      return p._store = {}, Object.defineProperty(p._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(p, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: l
      }), Object.defineProperty(p, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: v
      }), Object.freeze && (Object.freeze(p.props), Object.freeze(p)), p;
    };
    function Tr(e, o, s, l, v) {
      {
        var h, b = {}, p = null, w = null;
        s !== void 0 && (Ie(s), p = "" + s), Rr(o) && (Ie(o.key), p = "" + o.key), Er(o) && (w = o.ref, wr(o, v));
        for (h in o)
          J.call(o, h) && !Sr.hasOwnProperty(h) && (b[h] = o[h]);
        if (e && e.defaultProps) {
          var x = e.defaultProps;
          for (h in x)
            b[h] === void 0 && (b[h] = x[h]);
        }
        if (p || w) {
          var S = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
          p && Pr(b, S), w && _r(b, S);
        }
        return Cr(e, p, w, v, l, z.current, b);
      }
    }
    var oe = _.ReactCurrentOwner, De = _.ReactDebugCurrentFrame;
    function I(e) {
      if (e) {
        var o = e._owner, s = G(e.type, e._source, o ? o.type : null);
        De.setExtraStackFrame(s);
      } else
        De.setExtraStackFrame(null);
    }
    var ie;
    ie = !1;
    function se(e) {
      return typeof e == "object" && e !== null && e.$$typeof === r;
    }
    function Ae() {
      {
        if (oe.current) {
          var e = C(oe.current.type);
          if (e)
            return `

Check the render method of \`` + e + "`.";
        }
        return "";
      }
    }
    function kr(e) {
      {
        if (e !== void 0) {
          var o = e.fileName.replace(/^.*[\\\/]/, ""), s = e.lineNumber;
          return `

Check your code at ` + o + ":" + s + ".";
        }
        return "";
      }
    }
    var ze = {};
    function Or(e) {
      {
        var o = Ae();
        if (!o) {
          var s = typeof e == "string" ? e : e.displayName || e.name;
          s && (o = `

Check the top-level render call using <` + s + ">.");
        }
        return o;
      }
    }
    function Me(e, o) {
      {
        if (!e._store || e._store.validated || e.key != null)
          return;
        e._store.validated = !0;
        var s = Or(o);
        if (ze[s])
          return;
        ze[s] = !0;
        var l = "";
        e && e._owner && e._owner !== oe.current && (l = " It was passed a child from " + C(e._owner.type) + "."), I(e), R('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', s, l), I(null);
      }
    }
    function We(e, o) {
      {
        if (typeof e != "object")
          return;
        if (ne(e))
          for (var s = 0; s < e.length; s++) {
            var l = e[s];
            se(l) && Me(l, o);
          }
        else if (se(e))
          e._store && (e._store.validated = !0);
        else if (e) {
          var v = q(e);
          if (typeof v == "function" && v !== e.entries)
            for (var h = v.call(e), b; !(b = h.next()).done; )
              se(b.value) && Me(b.value, o);
        }
      }
    }
    function jr(e) {
      {
        var o = e.type;
        if (o == null || typeof o == "string")
          return;
        var s;
        if (typeof o == "function")
          s = o.propTypes;
        else if (typeof o == "object" && (o.$$typeof === d || o.$$typeof === y))
          s = o.propTypes;
        else
          return;
        if (s) {
          var l = C(o);
          vr(s, e.props, "prop", l, e);
        } else if (o.PropTypes !== void 0 && !ie) {
          ie = !0;
          var v = C(o);
          R("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", v || "Unknown");
        }
        typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && R("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function Ir(e) {
      {
        for (var o = Object.keys(e.props), s = 0; s < o.length; s++) {
          var l = o[s];
          if (l !== "children" && l !== "key") {
            I(e), R("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", l), I(null);
            break;
          }
        }
        e.ref !== null && (I(e), R("Invalid attribute `ref` supplied to `React.Fragment`."), I(null));
      }
    }
    function Ye(e, o, s, l, v, h) {
      {
        var b = lr(e);
        if (!b) {
          var p = "";
          (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (p += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var w = kr(v);
          w ? p += w : p += Ae();
          var x;
          e === null ? x = "null" : ne(e) ? x = "array" : e !== void 0 && e.$$typeof === r ? (x = "<" + (C(e.type) || "Unknown") + " />", p = " Did you accidentally export a JSX literal instead of a component?") : x = typeof e, R("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", x, p);
        }
        var S = Tr(e, o, s, v, h);
        if (S == null)
          return S;
        if (b) {
          var P = o.children;
          if (P !== void 0)
            if (l)
              if (ne(P)) {
                for (var F = 0; F < P.length; F++)
                  We(P[F], e);
                Object.freeze && Object.freeze(P);
              } else
                R("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              We(P, e);
        }
        return e === i ? Ir(S) : jr(S), S;
      }
    }
    function Fr(e, o, s) {
      return Ye(e, o, s, !0);
    }
    function $r(e, o, s) {
      return Ye(e, o, s, !1);
    }
    var Dr = $r, Ar = Fr;
    W.Fragment = i, W.jsx = Dr, W.jsxs = Ar;
  }()), W;
}
(function(t) {
  process.env.NODE_ENV === "production" ? t.exports = Jr() : t.exports = Xr();
})(ge);
const L = ge.exports.jsx, Kr = ge.exports.jsxs;
function Zr(t, r) {
  const n = Gr(t), [i, a] = Br({
    name: r
  });
  function u({
    children: c
  }) {
    return /* @__PURE__ */ L(i, {
      value: n,
      children: c
    });
  }
  function f(c) {
    const g = a();
    return Wr(g.subscribe, () => c ? c(g.get()) : g.get(), () => c ? c(t) : t);
  }
  function m(c) {
    const g = a(), y = Yr((E) => {
      c && g.setProperty(c, E);
    }, [g, c]);
    return c ? y : g.set;
  }
  function d(c, g) {
    if (typeof c == "object")
      return n.set(c);
    typeof c == "string" && be(g) && n.setProperty(c, g);
  }
  return Object.freeze({
    Provider: u,
    useStore: f,
    useStoreDispatch: m,
    getState: n.get,
    setState: d,
    subscribe(c) {
      return n.subscribe(() => {
        c(n.get());
      });
    }
  });
}
const Qr = {
  rules: [],
  globalStyle: {
    color: "#ffffff",
    height: "40px",
    width: "40px"
  },
  cursor: null
}, { Provider: Vr, useStore: K, useStoreDispatch: et, getState: Qe, subscribe: At, setState: ve } = Zr(Qr, "Cursor"), rt = ve.bind(null, "globalStyle"), Q = ve.bind(null, "rules");
ve.bind(null, "cursor");
function le(t, r, n, i) {
  const a = j(r);
  me(() => {
    a.current = r;
  }, [r]), Lr(() => {
    var m;
    const u = (m = n == null ? void 0 : n.current) != null ? m : window;
    if (!(u && u.addEventListener))
      return;
    const f = (d) => a.current(d);
    return u.addEventListener(t, f, i), () => {
      u.removeEventListener(t, f, i);
    };
  }, [t, n, i]);
}
function Ve(t, r, n) {
  const i = j(document.body), a = n != null ? n : i;
  le("mouseover", t, a), le("mouseout", r, a);
}
function tt(t) {
  if (t === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return t;
}
function H(t, r) {
  return H = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(i, a) {
    return i.__proto__ = a, i;
  }, H(t, r);
}
function nt(t, r) {
  t.prototype = Object.create(r.prototype), t.prototype.constructor = t, H(t, r);
}
function ce(t) {
  return ce = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function(n) {
    return n.__proto__ || Object.getPrototypeOf(n);
  }, ce(t);
}
function at(t) {
  return Function.toString.call(t).indexOf("[native code]") !== -1;
}
function ot() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
    return !1;
  if (typeof Proxy == "function")
    return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function Z(t, r, n) {
  return ot() ? Z = Reflect.construct.bind() : Z = function(a, u, f) {
    var m = [null];
    m.push.apply(m, u);
    var d = Function.bind.apply(a, m), c = new d();
    return f && H(c, f.prototype), c;
  }, Z.apply(null, arguments);
}
function de(t) {
  var r = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
  return de = function(i) {
    if (i === null || !at(i))
      return i;
    if (typeof i != "function")
      throw new TypeError("Super expression must either be null or a function");
    if (typeof r < "u") {
      if (r.has(i))
        return r.get(i);
      r.set(i, a);
    }
    function a() {
      return Z(i, arguments, ce(this).constructor);
    }
    return a.prototype = Object.create(i.prototype, {
      constructor: {
        value: a,
        enumerable: !1,
        writable: !0,
        configurable: !0
      }
    }), H(a, i);
  }, de(t);
}
var it = {
  1: `Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).

`,
  2: `Passed invalid arguments to hsla, please pass multiple numbers e.g. hsla(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).

`,
  3: `Passed an incorrect argument to a color function, please pass a string representation of a color.

`,
  4: `Couldn't generate valid rgb string from %s, it returned %s.

`,
  5: `Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.

`,
  6: `Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).

`,
  7: `Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).

`,
  8: `Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.

`,
  9: `Please provide a number of steps to the modularScale helper.

`,
  10: `Please pass a number or one of the predefined scales to the modularScale helper as the ratio.

`,
  11: `Invalid value passed as base to modularScale, expected number or em string but got "%s"

`,
  12: `Expected a string ending in "px" or a number passed as the first argument to %s(), got "%s" instead.

`,
  13: `Expected a string ending in "px" or a number passed as the second argument to %s(), got "%s" instead.

`,
  14: `Passed invalid pixel value ("%s") to %s(), please pass a value like "12px" or 12.

`,
  15: `Passed invalid base value ("%s") to %s(), please pass a value like "12px" or 12.

`,
  16: `You must provide a template to this method.

`,
  17: `You passed an unsupported selector state to this method.

`,
  18: `minScreen and maxScreen must be provided as stringified numbers with the same units.

`,
  19: `fromSize and toSize must be provided as stringified numbers with the same units.

`,
  20: `expects either an array of objects or a single object with the properties prop, fromSize, and toSize.

`,
  21: "expects the objects in the first argument array to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
  22: "expects the first argument object to have the properties `prop`, `fromSize`, and `toSize`.\n\n",
  23: `fontFace expects a name of a font-family.

`,
  24: `fontFace expects either the path to the font file(s) or a name of a local copy.

`,
  25: `fontFace expects localFonts to be an array.

`,
  26: `fontFace expects fileFormats to be an array.

`,
  27: `radialGradient requries at least 2 color-stops to properly render.

`,
  28: `Please supply a filename to retinaImage() as the first argument.

`,
  29: `Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.

`,
  30: "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
  31: `The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation

`,
  32: `To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])
To pass a single animation please supply them in simple values, e.g. animation('rotate', '2s')

`,
  33: `The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation

`,
  34: `borderRadius expects a radius value as a string or number as the second argument.

`,
  35: `borderRadius expects one of "top", "bottom", "left" or "right" as the first argument.

`,
  36: `Property must be a string value.

`,
  37: `Syntax Error at %s.

`,
  38: `Formula contains a function that needs parentheses at %s.

`,
  39: `Formula is missing closing parenthesis at %s.

`,
  40: `Formula has too many closing parentheses at %s.

`,
  41: `All values in a formula must have the same unit or be unitless.

`,
  42: `Please provide a number of steps to the modularScale helper.

`,
  43: `Please pass a number or one of the predefined scales to the modularScale helper as the ratio.

`,
  44: `Invalid value passed as base to modularScale, expected number or em/rem string but got %s.

`,
  45: `Passed invalid argument to hslToColorString, please pass a HslColor or HslaColor object.

`,
  46: `Passed invalid argument to rgbToColorString, please pass a RgbColor or RgbaColor object.

`,
  47: `minScreen and maxScreen must be provided as stringified numbers with the same units.

`,
  48: `fromSize and toSize must be provided as stringified numbers with the same units.

`,
  49: `Expects either an array of objects or a single object with the properties prop, fromSize, and toSize.

`,
  50: `Expects the objects in the first argument array to have the properties prop, fromSize, and toSize.

`,
  51: `Expects the first argument object to have the properties prop, fromSize, and toSize.

`,
  52: `fontFace expects either the path to the font file(s) or a name of a local copy.

`,
  53: `fontFace expects localFonts to be an array.

`,
  54: `fontFace expects fileFormats to be an array.

`,
  55: `fontFace expects a name of a font-family.

`,
  56: `linearGradient requries at least 2 color-stops to properly render.

`,
  57: `radialGradient requries at least 2 color-stops to properly render.

`,
  58: `Please supply a filename to retinaImage() as the first argument.

`,
  59: `Passed invalid argument to triangle, please pass correct pointingDirection e.g. 'right'.

`,
  60: "Passed an invalid value to `height` or `width`. Please provide a pixel based unit.\n\n",
  61: `Property must be a string value.

`,
  62: `borderRadius expects a radius value as a string or number as the second argument.

`,
  63: `borderRadius expects one of "top", "bottom", "left" or "right" as the first argument.

`,
  64: `The animation shorthand only takes 8 arguments. See the specification for more information: http://mdn.io/animation.

`,
  65: `To pass multiple animations please supply them in arrays, e.g. animation(['rotate', '2s'], ['move', '1s'])\\nTo pass a single animation please supply them in simple values, e.g. animation('rotate', '2s').

`,
  66: `The animation shorthand arrays can only have 8 elements. See the specification for more information: http://mdn.io/animation.

`,
  67: `You must provide a template to this method.

`,
  68: `You passed an unsupported selector state to this method.

`,
  69: `Expected a string ending in "px" or a number passed as the first argument to %s(), got %s instead.

`,
  70: `Expected a string ending in "px" or a number passed as the second argument to %s(), got %s instead.

`,
  71: `Passed invalid pixel value %s to %s(), please pass a value like "12px" or 12.

`,
  72: `Passed invalid base value %s to %s(), please pass a value like "12px" or 12.

`,
  73: `Please provide a valid CSS variable.

`,
  74: `CSS variable not found and no default was provided.

`,
  75: `important requires a valid style object, got a %s instead.

`,
  76: `fromSize and toSize must be provided as stringified numbers with the same units as minScreen and maxScreen.

`,
  77: `remToPx expects a value in "rem" but you provided it in "%s".

`,
  78: `base must be set in "px" or "%" but you set it in "%s".
`
};
function st() {
  for (var t = arguments.length, r = new Array(t), n = 0; n < t; n++)
    r[n] = arguments[n];
  var i = r[0], a = [], u;
  for (u = 1; u < r.length; u += 1)
    a.push(r[u]);
  return a.forEach(function(f) {
    i = i.replace(/%[a-z]/, f);
  }), i;
}
var D = /* @__PURE__ */ function(t) {
  nt(r, t);
  function r(n) {
    var i;
    if (process.env.NODE_ENV === "production")
      i = t.call(this, "An error occurred. See https://github.com/styled-components/polished/blob/main/src/internalHelpers/errors.md#" + n + " for more information.") || this;
    else {
      for (var a = arguments.length, u = new Array(a > 1 ? a - 1 : 0), f = 1; f < a; f++)
        u[f - 1] = arguments[f];
      i = t.call(this, st.apply(void 0, [it[n]].concat(u))) || this;
    }
    return tt(i);
  }
  return r;
}(/* @__PURE__ */ de(Error));
function ue(t) {
  return Math.round(t * 255);
}
function ut(t, r, n) {
  return ue(t) + "," + ue(r) + "," + ue(n);
}
function qe(t, r, n, i) {
  if (i === void 0 && (i = ut), r === 0)
    return i(n, n, n);
  var a = (t % 360 + 360) % 360 / 60, u = (1 - Math.abs(2 * n - 1)) * r, f = u * (1 - Math.abs(a % 2 - 1)), m = 0, d = 0, c = 0;
  a >= 0 && a < 1 ? (m = u, d = f) : a >= 1 && a < 2 ? (m = f, d = u) : a >= 2 && a < 3 ? (d = u, c = f) : a >= 3 && a < 4 ? (d = f, c = u) : a >= 4 && a < 5 ? (m = f, c = u) : a >= 5 && a < 6 && (m = u, c = f);
  var g = n - u / 2, y = m + g, E = d + g, k = c + g;
  return i(y, E, k);
}
var Ue = {
  aliceblue: "f0f8ff",
  antiquewhite: "faebd7",
  aqua: "00ffff",
  aquamarine: "7fffd4",
  azure: "f0ffff",
  beige: "f5f5dc",
  bisque: "ffe4c4",
  black: "000",
  blanchedalmond: "ffebcd",
  blue: "0000ff",
  blueviolet: "8a2be2",
  brown: "a52a2a",
  burlywood: "deb887",
  cadetblue: "5f9ea0",
  chartreuse: "7fff00",
  chocolate: "d2691e",
  coral: "ff7f50",
  cornflowerblue: "6495ed",
  cornsilk: "fff8dc",
  crimson: "dc143c",
  cyan: "00ffff",
  darkblue: "00008b",
  darkcyan: "008b8b",
  darkgoldenrod: "b8860b",
  darkgray: "a9a9a9",
  darkgreen: "006400",
  darkgrey: "a9a9a9",
  darkkhaki: "bdb76b",
  darkmagenta: "8b008b",
  darkolivegreen: "556b2f",
  darkorange: "ff8c00",
  darkorchid: "9932cc",
  darkred: "8b0000",
  darksalmon: "e9967a",
  darkseagreen: "8fbc8f",
  darkslateblue: "483d8b",
  darkslategray: "2f4f4f",
  darkslategrey: "2f4f4f",
  darkturquoise: "00ced1",
  darkviolet: "9400d3",
  deeppink: "ff1493",
  deepskyblue: "00bfff",
  dimgray: "696969",
  dimgrey: "696969",
  dodgerblue: "1e90ff",
  firebrick: "b22222",
  floralwhite: "fffaf0",
  forestgreen: "228b22",
  fuchsia: "ff00ff",
  gainsboro: "dcdcdc",
  ghostwhite: "f8f8ff",
  gold: "ffd700",
  goldenrod: "daa520",
  gray: "808080",
  green: "008000",
  greenyellow: "adff2f",
  grey: "808080",
  honeydew: "f0fff0",
  hotpink: "ff69b4",
  indianred: "cd5c5c",
  indigo: "4b0082",
  ivory: "fffff0",
  khaki: "f0e68c",
  lavender: "e6e6fa",
  lavenderblush: "fff0f5",
  lawngreen: "7cfc00",
  lemonchiffon: "fffacd",
  lightblue: "add8e6",
  lightcoral: "f08080",
  lightcyan: "e0ffff",
  lightgoldenrodyellow: "fafad2",
  lightgray: "d3d3d3",
  lightgreen: "90ee90",
  lightgrey: "d3d3d3",
  lightpink: "ffb6c1",
  lightsalmon: "ffa07a",
  lightseagreen: "20b2aa",
  lightskyblue: "87cefa",
  lightslategray: "789",
  lightslategrey: "789",
  lightsteelblue: "b0c4de",
  lightyellow: "ffffe0",
  lime: "0f0",
  limegreen: "32cd32",
  linen: "faf0e6",
  magenta: "f0f",
  maroon: "800000",
  mediumaquamarine: "66cdaa",
  mediumblue: "0000cd",
  mediumorchid: "ba55d3",
  mediumpurple: "9370db",
  mediumseagreen: "3cb371",
  mediumslateblue: "7b68ee",
  mediumspringgreen: "00fa9a",
  mediumturquoise: "48d1cc",
  mediumvioletred: "c71585",
  midnightblue: "191970",
  mintcream: "f5fffa",
  mistyrose: "ffe4e1",
  moccasin: "ffe4b5",
  navajowhite: "ffdead",
  navy: "000080",
  oldlace: "fdf5e6",
  olive: "808000",
  olivedrab: "6b8e23",
  orange: "ffa500",
  orangered: "ff4500",
  orchid: "da70d6",
  palegoldenrod: "eee8aa",
  palegreen: "98fb98",
  paleturquoise: "afeeee",
  palevioletred: "db7093",
  papayawhip: "ffefd5",
  peachpuff: "ffdab9",
  peru: "cd853f",
  pink: "ffc0cb",
  plum: "dda0dd",
  powderblue: "b0e0e6",
  purple: "800080",
  rebeccapurple: "639",
  red: "f00",
  rosybrown: "bc8f8f",
  royalblue: "4169e1",
  saddlebrown: "8b4513",
  salmon: "fa8072",
  sandybrown: "f4a460",
  seagreen: "2e8b57",
  seashell: "fff5ee",
  sienna: "a0522d",
  silver: "c0c0c0",
  skyblue: "87ceeb",
  slateblue: "6a5acd",
  slategray: "708090",
  slategrey: "708090",
  snow: "fffafa",
  springgreen: "00ff7f",
  steelblue: "4682b4",
  tan: "d2b48c",
  teal: "008080",
  thistle: "d8bfd8",
  tomato: "ff6347",
  turquoise: "40e0d0",
  violet: "ee82ee",
  wheat: "f5deb3",
  white: "fff",
  whitesmoke: "f5f5f5",
  yellow: "ff0",
  yellowgreen: "9acd32"
};
function ft(t) {
  if (typeof t != "string")
    return t;
  var r = t.toLowerCase();
  return Ue[r] ? "#" + Ue[r] : t;
}
var lt = /^#[a-fA-F0-9]{6}$/, ct = /^#[a-fA-F0-9]{8}$/, dt = /^#[a-fA-F0-9]{3}$/, pt = /^#[a-fA-F0-9]{4}$/, fe = /^rgb\(\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*\)$/i, mt = /^rgb(?:a)?\(\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,)?\s*(\d{1,3})\s*(?:,|\/)\s*([-+]?\d*[.]?\d+[%]?)\s*\)$/i, bt = /^hsl\(\s*(\d{0,3}[.]?[0-9]+(?:deg)?)\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*\)$/i, gt = /^hsl(?:a)?\(\s*(\d{0,3}[.]?[0-9]+(?:deg)?)\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,)?\s*(\d{1,3}[.]?[0-9]?)%\s*(?:,|\/)\s*([-+]?\d*[.]?\d+[%]?)\s*\)$/i;
function vt(t) {
  if (typeof t != "string")
    throw new D(3);
  var r = ft(t);
  if (r.match(lt))
    return {
      red: parseInt("" + r[1] + r[2], 16),
      green: parseInt("" + r[3] + r[4], 16),
      blue: parseInt("" + r[5] + r[6], 16)
    };
  if (r.match(ct)) {
    var n = parseFloat((parseInt("" + r[7] + r[8], 16) / 255).toFixed(2));
    return {
      red: parseInt("" + r[1] + r[2], 16),
      green: parseInt("" + r[3] + r[4], 16),
      blue: parseInt("" + r[5] + r[6], 16),
      alpha: n
    };
  }
  if (r.match(dt))
    return {
      red: parseInt("" + r[1] + r[1], 16),
      green: parseInt("" + r[2] + r[2], 16),
      blue: parseInt("" + r[3] + r[3], 16)
    };
  if (r.match(pt)) {
    var i = parseFloat((parseInt("" + r[4] + r[4], 16) / 255).toFixed(2));
    return {
      red: parseInt("" + r[1] + r[1], 16),
      green: parseInt("" + r[2] + r[2], 16),
      blue: parseInt("" + r[3] + r[3], 16),
      alpha: i
    };
  }
  var a = fe.exec(r);
  if (a)
    return {
      red: parseInt("" + a[1], 10),
      green: parseInt("" + a[2], 10),
      blue: parseInt("" + a[3], 10)
    };
  var u = mt.exec(r.substring(0, 50));
  if (u)
    return {
      red: parseInt("" + u[1], 10),
      green: parseInt("" + u[2], 10),
      blue: parseInt("" + u[3], 10),
      alpha: parseFloat("" + u[4]) > 1 ? parseFloat("" + u[4]) / 100 : parseFloat("" + u[4])
    };
  var f = bt.exec(r);
  if (f) {
    var m = parseInt("" + f[1], 10), d = parseInt("" + f[2], 10) / 100, c = parseInt("" + f[3], 10) / 100, g = "rgb(" + qe(m, d, c) + ")", y = fe.exec(g);
    if (!y)
      throw new D(4, r, g);
    return {
      red: parseInt("" + y[1], 10),
      green: parseInt("" + y[2], 10),
      blue: parseInt("" + y[3], 10)
    };
  }
  var E = gt.exec(r.substring(0, 50));
  if (E) {
    var k = parseInt("" + E[1], 10), N = parseInt("" + E[2], 10) / 100, V = parseInt("" + E[3], 10) / 100, q = "rgb(" + qe(k, N, V) + ")", _ = fe.exec(q);
    if (!_)
      throw new D(4, r, q);
    return {
      red: parseInt("" + _[1], 10),
      green: parseInt("" + _[2], 10),
      blue: parseInt("" + _[3], 10),
      alpha: parseFloat("" + E[4]) > 1 ? parseFloat("" + E[4]) / 100 : parseFloat("" + E[4])
    };
  }
  throw new D(5);
}
var ht = function(r) {
  return r.length === 7 && r[1] === r[2] && r[3] === r[4] && r[5] === r[6] ? "#" + r[1] + r[3] + r[5] : r;
}, Be = ht;
function $(t) {
  var r = t.toString(16);
  return r.length === 1 ? "0" + r : r;
}
function Ge(t, r, n) {
  if (typeof t == "number" && typeof r == "number" && typeof n == "number")
    return Be("#" + $(t) + $(r) + $(n));
  if (typeof t == "object" && r === void 0 && n === void 0)
    return Be("#" + $(t.red) + $(t.green) + $(t.blue));
  throw new D(6);
}
function yt(t, r, n, i) {
  if (typeof t == "string" && typeof r == "number") {
    var a = vt(t);
    return "rgba(" + a.red + "," + a.green + "," + a.blue + "," + r + ")";
  } else {
    if (typeof t == "number" && typeof r == "number" && typeof n == "number" && typeof i == "number")
      return i >= 1 ? Ge(t, r, n) : "rgba(" + t + "," + r + "," + n + "," + i + ")";
    if (typeof t == "object" && r === void 0 && n === void 0 && i === void 0)
      return t.alpha >= 1 ? Ge(t.red, t.green, t.blue) : "rgba(" + t.red + "," + t.green + "," + t.blue + "," + t.alpha + ")";
  }
  throw new D(7);
}
function xt(t, r) {
  const n = r.getBoundingClientRect();
  return {
    x: t.pageX - n.left - window.pageXOffset,
    y: t.pageY - n.top - window.pageYOffset
  };
}
function St({ event: t, cursor: r, image: n, zoom: i = 2 }) {
  const { x: a, y: u } = xt(t, n), f = n.offsetWidth, m = n.offsetHeight, d = r.offsetWidth / 2, c = r.offsetHeight / 2, g = `-${a * i - d}px -${u * i - c}px`, y = `${f * i}px ${m * i}px`;
  r.style.backgroundImage = `url(${n.src})`, r.style.backgroundPosition = g, r.style.backgroundRepeat = "no-repeat", r.style.backgroundSize = y;
}
let Y;
const Et = function({ target: r }) {
  const n = r == null ? void 0 : r.current, { cursor: i } = Qe();
  if (!r || !i)
    return {};
  if (!(n instanceof HTMLImageElement))
    throw Error("Zoom can only be used on an image.");
  return Y == null || Y.abort(), Y = new AbortController(), n.addEventListener("mousemove", (a) => St({ event: a, image: n, cursor: i }), {
    signal: Y.signal
  }), {
    backgroundImage: "none",
    backgroundPosition: "inherit",
    backgroundRepeat: "inherit",
    backgroundSize: "inherit"
  };
}, er = {
  Difference: {
    mixBlendMode: "difference"
  },
  Fill: ({ color: t }) => ({
    backgroundColor: t
  }),
  Glow: ({ color: t }) => ({
    boxShadow: `2px -3px 41px -1px ${yt(t, 0.64)}`
  }),
  Grow: {
    transform: "scale(1.4)"
  },
  Zoom: Et
}, Rt = function({ target: r }) {
  const n = r == null ? void 0 : r.current, { cursor: i } = Qe();
  if (!r || !i)
    return {};
  if (!(n instanceof HTMLImageElement))
    throw Error("Mask can only be used on an image.");
  const { src: a } = n;
  if (!a.endsWith(".svg"))
    throw Error("A mask can only defined with an SVG.");
  return {
    maskImage: `url(${a})`,
    WebkitMaskImage: `url(${a})`,
    maskRepeat: "no-repeat",
    WebkitMaskRepeat: "no-repeat",
    maskSize: "cover",
    WebkitMaskSize: "cover"
  };
};
function pe({ width: t, height: r, color: n }) {
  return {
    border: `3px solid ${n}`,
    width: t,
    height: r
  };
}
function wt(t) {
  return {
    ...pe(t),
    borderRadius: "50%"
  };
}
const rr = {
  Diamond: (t) => ({
    ...pe(t),
    transform: "rotate(45deg)"
  }),
  Ring: wt,
  Mask: Rt,
  Square: pe
}, Pt = {
  position: "absolute",
  pointerEvents: "none"
};
function _t({
  style: t,
  globalStyle: r,
  target: n,
  cursor: i
}) {
  return t ? typeof t == "object" ? t : t({ ...r, target: n, cursor: i }) : {};
}
function Ct(t) {
  return t.split(".");
}
function tr(t) {
  return (r) => {
    function n() {
      if (typeof r == "string") {
        const [i, a] = Ct(r);
        switch (i) {
          case "Effect":
            return er[a];
          case "Shape":
            return rr[a];
          default:
            throw Error(`Invalid call to useCursorStyleOnHover(${r})`);
        }
      }
      return r;
    }
    return { style: n(), context: { target: t } };
  };
}
function Tt(t) {
  const r = j(document.body.style.cursor);
  Ve(
    () => document.body.style.cursor = "none",
    () => document.body.style.cursor = r.current,
    t
  );
}
function kt({ color: t, height: r, width: n } = {}) {
  return me(() => {
    const i = Object.entries({ color: t, height: r, width: n }).filter(([, a]) => be(a)).reduce((a, [u, f]) => ({ ...a, [u]: f }), {});
    rt((a) => ({ ...a, globalStyle: i }));
  }, [t, r, n]), K((i) => i.globalStyle);
}
function Ot() {
  const t = et("cursor"), r = K((f) => f.cursor), n = K((f) => f.globalStyle), i = K((f) => f.rules).map(
    ({ style: f, context: m }) => _t({
      style: f,
      globalStyle: n,
      target: m == null ? void 0 : m.target,
      cursor: r
    })
  ), a = i.map(({ transform: f }) => f).filter(be).join(" "), u = Object.assign({}, Pt, ...i, {
    transform: a
  });
  return le("mousemove", (f) => {
    r && (r.style.top = f.pageY + "px", r.style.left = f.pageX + "px");
  }), { ref: t, style: u };
}
function nr(...t) {
  const r = j(null), n = j(Ze(t, tr(r)));
  return me(() => {
    const i = n.current;
    return Q((a) => [...a, ...i]), () => Q((a) => a.filter((u) => i.every(Ke(u))));
  }, []), r;
}
function zt(...t) {
  const r = j(null), n = j(Ze(t, tr(r)));
  return Ve(
    () => Q((i) => [...i, ...n.current]),
    () => Q((i) => i.filter((a) => n.current.every(Ke(a)))),
    r
  ), r;
}
const jt = Hr(function() {
  return /* @__PURE__ */ L("div", {
    ...Ot()
  });
});
function It() {
  return Tt(), null;
}
function Ft(t) {
  return kt(t), nr(({
    width: r,
    height: n
  }) => ({
    transform: `translateX(calc(-${r} / 2)) translateY(calc(-${n} / 2))`
  })), null;
}
function $t({
  children: t,
  hideDefaultCursor: r = !0,
  ...n
}) {
  return /* @__PURE__ */ Kr(Vr, {
    children: [/* @__PURE__ */ L(Ft, {
      ...n
    }), t, r && /* @__PURE__ */ L(It, {}), /* @__PURE__ */ L(jt, {})]
  });
}
function Je(t) {
  return Object.entries(t).reduce(
    (r, [n, i]) => ({
      ...r,
      [n]: ({ children: a }) => {
        const u = nr(i);
        if (Nr(a)) {
          const f = qr.only(a);
          return Ur(f, {
            ...a.props,
            ref: (m) => {
              u.current = m;
              const d = f.ref;
              typeof d == "function" ? d(m) : d && (d.current = m);
            }
          });
        }
      }
    }),
    {}
  );
}
const Mt = {
  Provider: $t,
  Shapes: Je(rr),
  Effects: Je(er)
};
export {
  Mt as Cursor,
  rt as setGlobalStyle,
  nr as useCursorStyle,
  zt as useCursorStyleOnHover,
  kt as useGlobalStyle,
  Tt as useHideSystemCursor
};
//# sourceMappingURL=use-custom-cursor.es.js.map
