import { ReactElement } from 'react';
import { CursorProvider } from './core';
declare type CursorComponent = (props: {
    children?: ReactElement;
}) => ReactElement;
export declare const Cursor: {
    Provider: typeof CursorProvider;
    Shapes: Record<"Diamond" | "Mask" | "Ring" | "Square", CursorComponent>;
    Effects: Record<"Difference" | "Fill" | "Glow" | "Grow" | "Zoom", CursorComponent>;
};
export { setGlobalStyle, useCursorStyle, useCursorStyleOnHover, useGlobalStyle, useHideSystemCursor, } from './core';
